// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v3.12.4
// source: rhyzome_protos/openwrt.proto

package rhyzome_protos

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// RhyzomeOpenwrtClient is the client API for RhyzomeOpenwrt service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type RhyzomeOpenwrtClient interface {
	EventStream(ctx context.Context, opts ...grpc.CallOption) (RhyzomeOpenwrt_EventStreamClient, error)
}

type rhyzomeOpenwrtClient struct {
	cc grpc.ClientConnInterface
}

func NewRhyzomeOpenwrtClient(cc grpc.ClientConnInterface) RhyzomeOpenwrtClient {
	return &rhyzomeOpenwrtClient{cc}
}

func (c *rhyzomeOpenwrtClient) EventStream(ctx context.Context, opts ...grpc.CallOption) (RhyzomeOpenwrt_EventStreamClient, error) {
	stream, err := c.cc.NewStream(ctx, &RhyzomeOpenwrt_ServiceDesc.Streams[0], "/protos.RhyzomeOpenwrt/EventStream", opts...)
	if err != nil {
		return nil, err
	}
	x := &rhyzomeOpenwrtEventStreamClient{stream}
	return x, nil
}

type RhyzomeOpenwrt_EventStreamClient interface {
	Send(*OpenwrtEventUpdate) error
	Recv() (*OpenwrtEvent, error)
	grpc.ClientStream
}

type rhyzomeOpenwrtEventStreamClient struct {
	grpc.ClientStream
}

func (x *rhyzomeOpenwrtEventStreamClient) Send(m *OpenwrtEventUpdate) error {
	return x.ClientStream.SendMsg(m)
}

func (x *rhyzomeOpenwrtEventStreamClient) Recv() (*OpenwrtEvent, error) {
	m := new(OpenwrtEvent)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// RhyzomeOpenwrtServer is the server API for RhyzomeOpenwrt service.
// All implementations must embed UnimplementedRhyzomeOpenwrtServer
// for forward compatibility
type RhyzomeOpenwrtServer interface {
	EventStream(RhyzomeOpenwrt_EventStreamServer) error
	mustEmbedUnimplementedRhyzomeOpenwrtServer()
}

// UnimplementedRhyzomeOpenwrtServer must be embedded to have forward compatible implementations.
type UnimplementedRhyzomeOpenwrtServer struct {
}

func (UnimplementedRhyzomeOpenwrtServer) EventStream(RhyzomeOpenwrt_EventStreamServer) error {
	return status.Errorf(codes.Unimplemented, "method EventStream not implemented")
}
func (UnimplementedRhyzomeOpenwrtServer) mustEmbedUnimplementedRhyzomeOpenwrtServer() {}

// UnsafeRhyzomeOpenwrtServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to RhyzomeOpenwrtServer will
// result in compilation errors.
type UnsafeRhyzomeOpenwrtServer interface {
	mustEmbedUnimplementedRhyzomeOpenwrtServer()
}

func RegisterRhyzomeOpenwrtServer(s grpc.ServiceRegistrar, srv RhyzomeOpenwrtServer) {
	s.RegisterService(&RhyzomeOpenwrt_ServiceDesc, srv)
}

func _RhyzomeOpenwrt_EventStream_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(RhyzomeOpenwrtServer).EventStream(&rhyzomeOpenwrtEventStreamServer{stream})
}

type RhyzomeOpenwrt_EventStreamServer interface {
	Send(*OpenwrtEvent) error
	Recv() (*OpenwrtEventUpdate, error)
	grpc.ServerStream
}

type rhyzomeOpenwrtEventStreamServer struct {
	grpc.ServerStream
}

func (x *rhyzomeOpenwrtEventStreamServer) Send(m *OpenwrtEvent) error {
	return x.ServerStream.SendMsg(m)
}

func (x *rhyzomeOpenwrtEventStreamServer) Recv() (*OpenwrtEventUpdate, error) {
	m := new(OpenwrtEventUpdate)
	if err := x.ServerStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// RhyzomeOpenwrt_ServiceDesc is the grpc.ServiceDesc for RhyzomeOpenwrt service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var RhyzomeOpenwrt_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "protos.RhyzomeOpenwrt",
	HandlerType: (*RhyzomeOpenwrtServer)(nil),
	Methods:     []grpc.MethodDesc{},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "EventStream",
			Handler:       _RhyzomeOpenwrt_EventStream_Handler,
			ServerStreams: true,
			ClientStreams: true,
		},
	},
	Metadata: "rhyzome_protos/openwrt.proto",
}
